Option Explicit

' The Quicken for Windows DDE experimenter

' Public domain.

Global Const TITLE$ = "QWDE"
Global Const LONGT$ = "The Quicken/Windows DDE Experimenter"
Global Const QUICKEN = 0
Global Const QWRUN = 1

Global CR$          'General-purpose CR character (dec 13) for messages etc.
Global QEOI$        'Quickens end-of-DDE-item
Global REPLY$       'Reply to most recent DDE command

Global SYSITEMS$(2) 'SysItems of Quicken (0) and QWRUN (1)

' Some more stuff from CONSTANT.TXT - regardless if needed or not:
' Standard message constants
Global Const MB_OK% = 0
Global Const MB_OKCANCEL% = 1
Global Const MB_ABORTRETRYIGNORE% = 2
Global Const MB_YESNOCANCEL% = 3
Global Const MB_YESNO% = 4
Global Const MB_RETRYCANCEL% = 5
Global Const MB_ICONSTOP% = 16
Global Const MB_ICONQUESTION% = 32
Global Const MB_ICONEXCLAMATION% = 48
Global Const MB_ICONINFORMATION% = 64
Global Const MB_DEFBUTTON1% = 0
Global Const MB_DEFBUTTON2% = 256
Global Const MB_DEFBUTTON3% = 512
Global Const MB_APPLMODAL% = 0
Global Const MB_SYSTEMMODAL% = 4096
' Replies to messages
Global Const IDOK = 1
Global Const IDCANCEL = 2
Global Const IDABORT = 3
Global Const IDRETRY = 4
Global Const IDIGNORE = 5
Global Const IDYES = 6
Global Const IDNO = 7
' ErrNum (LinkError)
Global Const WRONG_FORMAT = 1
Global Const DDE_SOURCE_CLOSED = 6
Global Const TOO_MANY_LINKS = 7
Global Const DATA_TRANSFER_FAILED = 8
' MousePointer
Global Const Default = 0
Global Const HOURGLASS = 11
' LinkMode (forms and controls)
Global Const LINK_NONE = 0
Global Const LINK_SOURCE = 1
Global Const LINK_AUTOMATIC = 1
Global Const LINK_MANUAL = 2
' Run time errors
Global Const NO_APP_RESPONDED = 282
Global Const DDE_REFUSED = 285
' Key Codes
Global Const KEY_LBUTTON = &H1
Global Const KEY_RBUTTON = &H2
Global Const KEY_CANCEL = &H3
Global Const KEY_MBUTTON = &H4    ' NOT contiguous with L & RBUTTON
Global Const KEY_BACK = &H8
Global Const KEY_TAB = &H9
Global Const KEY_CLEAR = &HC
Global Const KEY_RETURN = &HD
Global Const KEY_SHIFT = &H10
Global Const KEY_CONTROL = &H11
Global Const KEY_MENU = &H12
Global Const KEY_PAUSE = &H13
Global Const KEY_CAPITAL = &H14
Global Const KEY_ESCAPE = &H1B
Global Const KEY_SPACE = &H20
Global Const KEY_PRIOR = &H21
Global Const KEY_NEXT = &H22
Global Const KEY_END = &H23
Global Const KEY_HOME = &H24
Global Const KEY_LEFT = &H25
Global Const KEY_UP = &H26
Global Const KEY_RIGHT = &H27
Global Const KEY_DOWN = &H28
Global Const KEY_SELECT = &H29
Global Const KEY_PRINT = &H2A
Global Const KEY_EXECUTE = &H2B
Global Const KEY_SNAPSHOT = &H2C
Global Const KEY_INSERT = &H2D
Global Const KEY_DELETE = &H2E
Global Const KEY_HELP = &H2F
' SetWindowPos
Global Const SWP_NOMOVE = 2
Global Const SWP_NOSIZE = 1
Global Const flags = SWP_NOMOVE Or SWP_NOSIZE
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2
' Other
Global Const MODAL% = 1
Global Const NONMODAL% = 0

Sub DDEExec ()

Dim pos%, p%
Dim exc$

On Error GoTo DDEE_Err

' set up command string to issue
exc$ = frmMain.cmbCommand.Text

' Parse command string,
' replacing placeholders by their values.
For p% = 0 To 5
    pos% = InStr(exc$, "<" + LTrim(Str$(p% + 1)) + ">")
    If pos% > 0 Then
        exc$ = Left$(exc$, pos% - 1) + frmMain.txtParam(p%).Text + Mid$(exc$, pos% + 3)
    End If
Next p%

' Foreward command to Quicken.
If Left$(exc$, 1) = "[" Then
    ' (A) True DDE command
    frmMain.txtDDE.LinkExecute exc$
    ' Return msg only if required
    If frmMain.chkRetMsg Then
        frmMain.txtDDE.LinkItem = "ReturnMessage"
        frmMain.txtDDE.LinkRequest
    Else
        frmMain.txtDDE.Text = ""
    End If
Else
    ' (B) Sysitem
    frmMain.txtDDE.LinkItem = exc$
    frmMain.txtDDE.LinkRequest
End If

' Give Windows (& Quicken) time to do their thing,
' then fetch our REPLY & exit
DoEvents
REPLY$ = frmMain.txtDDE.Text
GoTo DDEE_Exit

' Error trap
DDEE_Err:
REPLY$ = "[QWDE: DDE error - probably unknown command]"
Resume DDEE_Exit

' Setup return value & display
DDEE_Exit:
Call ShowReply

End Sub

Sub DDEExecPW ()

Dim rep$, cmd$

' First, send "Release()", and ignore the result
cmd$ = frmMain.cmbCommand.Text      'save command
frmMain.cmbCommand.Text = "[Release()]"
Call DDEExec

' Then send the password.
frmMain.cmbCommand.Text = "[Password(" + frmMain.txtPwd.Text + ")]"
Call DDEExec
frmMain.cmbCommand.Text = cmd$      'restore command

' Isolate "Accepted" or "Rejected" from reply to password.
REPLY$ = Left$(REPLY$, InStr(REPLY$, CR$) - 1) 'cut at cr

If REPLY$ = "Accepted" Then
    
    ' Send the command now...
    Call DDEExec
    rep$ = REPLY$                   'save reply

    ' ...followed by "Release".
    cmd$ = frmMain.cmbCommand.Text  'save command
    frmMain.cmbCommand.Text = "[Release()]"
    Call DDEExec
    frmMain.cmbCommand.Text = cmd$  'restore command
    REPLY$ = rep$                   'restore reply

Else
    
    ' Tell user *what* was rejected
    REPLY$ = REPLY$ + " [QWDE: Due to invalid Password]"

End If

' Re-display reply because if may have changed since DDEExec
Call ShowReply

End Sub

Sub ExitApp ()

' This is the only place to orderly leave the App,
' so nobody will have to search for hidden "END"s etc.
Unload frmMain
End

End Sub

Function InitDDE% (pgm%)
        
Dim ok%, lt$, msg$

' Init return value
ok% = False
    
' Make sure the link is not yet active.
frmMain.txtDDE.LinkMode = LINK_NONE
    
' Set up link name & topic.
If pgm% = QUICKEN Then lt$ = "Quicken"
If pgm% = QWRUN Then lt$ = "QWRUN"
frmMain.txtDDE.LinkTopic = lt$ + "|" + frmMain.txtTopic.Text
         
' Try to establish a "cold" (manual) link.
On Error Resume Next
frmMain.txtDDE.LinkMode = LINK_MANUAL
' Success?
ok% = (frmMain.txtDDE.LinkMode <> LINK_NONE)
    
If Not ok% Then
    msg$ = "Cannot link to " + lt$ + ", probably" + CR$
    msg$ = msg$ + "because " + lt$ + " is not running." + CR$ + CR$
    msg$ = msg$ + "Please start " + lt$ + " now," + CR$
    msg$ = msg$ + "then click OK and try again."
    MsgBox msg$, MB_ICONSTOP, TITLE$ + " Problem"
End If

InitDDE% = ok%

End Function

Sub Main ()

Dim done%, ddeok%, msg$, i%

' Init global vars
CR$ = Chr$(13)
QEOI$ = CR$ + Chr$(10)
REPLY$ = "[QWDE: None yet]"
SYSITEMS$(QUICKEN) = ""
SYSITEMS$(QWRUN) = ""

' Load form, init controls & props
Load frmMain
frmMain.Top = (Screen.Height - frmMain.Height) \ 2
frmMain.Left = (Screen.Width - frmMain.Width) \ 2
frmMain.Caption = LONGT$
frmMain.lblRetMsg.Caption = REPLY$
frmMain.txtTopic.Text = "System"
frmMain.optCommWith(0).Value = True
frmMain.txtPwd.Text = ""
For i% = 0 To 5
    frmMain.txtParam(i%).Text = ""
    frmMain.lblParam(i%).Caption = "&" + LTrim$(Str$(i% + 1))
Next i%

' Verify that QW is running, and set up a cold link.
If InitDDE%(QUICKEN) Then

    ' Get a list of available SysItems.
    frmMain.cmbCommand.Text = "SysItems"
    Call SetupParams
    Call DDEExec
    SYSITEMS$(QUICKEN) = REPLY$
    Call SetupCommandList(QUICKEN)
    If Len(REPLY$) > 0 Then
        ' Display form
        frmMain.Show MODAL
    End If

End If

' Quit.
Call ExitApp

End Sub

Sub SendCommand ()

' If Auto-PW/Release and privileged command,
' then send password-command-release,
' else send command only.
If frmMain.chkPwdRel.Value = 1 And frmMain.txtPwd.Visible Then
    Call DDEExecPW
Else
    Call DDEExec
End If

End Sub

Sub SetupCommandList (pgm%)

Dim it%, c%, ch$, flag%, item$

' Clear list
While frmMain.cmbCommand.ListCount
    frmMain.cmbCommand.RemoveItem 0
Wend

' Sysitems first
item$ = ""
flag% = False
For c% = 1 To Len(SYSITEMS$(pgm%))
    ch$ = Mid$(SYSITEMS$(pgm%), c%, 1)
    If ch$ = " " And Not flag% Then
        frmMain.cmbCommand.AddItem item$
        item$ = ""
        flag% = True
    ElseIf ch$ <> " " Then
        item$ = item$ + ch$
        flag% = False
    End If
Next c%

' True DDE commands second
If pgm% = QUICKEN Then
    frmMain.cmbCommand.AddItem "[CreatePayeeReport(?,?,?,?,?,?)] (PW!)"
    frmMain.cmbCommand.AddItem "[PayeeReportCell(?,?,?,?,?,?)]"
    frmMain.cmbCommand.AddItem "[SumValue(startdate,enddate,acctmask,payeemask,categ.mask,classmask)]"
    frmMain.cmbCommand.AddItem "[SetSecPrice(security,price)] (PW!)"
    frmMain.cmbCommand.AddItem "[GetAccountList()]"
    frmMain.cmbCommand.AddItem "[GetCategoryList()]"
    frmMain.cmbCommand.AddItem "[AddFullCategory(?,?,?,?,?,?)] (PW!)"
    frmMain.cmbCommand.AddItem "[GetTXPassword()]"
    frmMain.cmbCommand.AddItem "[GetSecurityList()]"
    frmMain.cmbCommand.AddItem "[GetSecurityGoalList()]"
    frmMain.cmbCommand.AddItem "[GetQuickenFile()]"
    frmMain.cmbCommand.AddItem "[OpenFile(filename,filepassword)] (PW!)"
    frmMain.cmbCommand.AddItem "[CreateTXFFile(begindate,enddate,filename)]"
    frmMain.cmbCommand.AddItem "[Release()]"
    frmMain.cmbCommand.AddItem "[AddCategory(category,description,type)] (PW!)"
    frmMain.cmbCommand.AddItem "[AddSecurity(?,?,?,?,?,?)] (PW!)"
    frmMain.cmbCommand.AddItem "[GetTransaction(account,begindate,payee,direction)]"
    frmMain.cmbCommand.AddItem "[DeleteTransactionTag(tx tag,account tag,date,amount)] (PW!)"
    frmMain.cmbCommand.AddItem "[DeletePayeeReport(?,?,?,?,?,?)] (PW!)"
    frmMain.cmbCommand.AddItem "[PayeeReportRow(?,?,?,?,?,?)]"
    frmMain.cmbCommand.AddItem "[SecPrice(?,?,?,?,?,?)] (PW!)"
    frmMain.cmbCommand.AddItem "[SecShareCount()]"
    frmMain.cmbCommand.AddItem "[GetAccountBalances()]"
    frmMain.cmbCommand.AddItem "[GetFullCategoryList()]"
    frmMain.cmbCommand.AddItem "[ReplaceCatTaxSched(?,?,?,?,?,?)] (PW!)"
    frmMain.cmbCommand.AddItem "[GetClassList()]"
    frmMain.cmbCommand.AddItem "[GetSecurityTypeList()]"
    frmMain.cmbCommand.AddItem "[GetQuickenVersion()]"
    frmMain.cmbCommand.AddItem "[GetLastOpenedFile()]"
    frmMain.cmbCommand.AddItem "[GetTaxScheduleVersion()]"
    frmMain.cmbCommand.AddItem "[Password(password)] (PW!)"
    frmMain.cmbCommand.AddItem "[AddAccount(account,description,type,date,amount)] (PW!)"
    frmMain.cmbCommand.AddItem "[AddClass(class,description)] (PW!)"
    frmMain.cmbCommand.AddItem "[AddTransaction(tx data)] (PW!)"
    frmMain.cmbCommand.AddItem "[GetRelativeTransaction(account,tx tag,payee,direction)]"
    frmMain.cmbCommand.AddItem "[GetSupportedCountries()]"
End If

If pgm% = QWRUN Then
    
    frmMain.cmbCommand.AddItem "[OpenSesame(void)]"
    frmMain.cmbCommand.AddItem "[CloseSesame(void)]"
    frmMain.cmbCommand.AddItem "[Quit(void)]"
    frmMain.cmbCommand.AddItem "[GetSupportedVersions(void)]"
    frmMain.cmbCommand.AddItem "[GetQWRUNVersion(void)]"

End If

End Sub

Sub SetupParams ()

Dim cmd$
Dim p%, par$, pos%, c%, ch$

' Initialize password entry field
cmd$ = frmMain.cmbCommand.Text
frmMain.lblPwd.Visible = False
frmMain.txtPwd.Visible = False
If Right$(cmd$, 6) = " (PW!)" Then
    frmMain.lblPwd.Visible = True
    frmMain.txtPwd.Visible = True
    cmd$ = Left$(cmd$, Len(cmd$) - 6)
End If

' Initialize params
For p% = 0 To 5
    frmMain.txtParam(p%).Text = ""
    frmMain.lblParam(p%).Caption = ""
    frmMain.txtParam(p%).Enabled = False
    frmMain.txtParam(p%).Visible = False
Next p%
frmMain.lblParam(0).Caption = "(none)"

' No params necessary if SysItem, or if empty paramlist
If Left$(cmd$, 1) <> "[" Then GoTo SP_Exit
If InStr(cmd$, "()") > 0 Then GoTo SP_Exit

' Read params from command & re-enable if necessary
p% = 0
par$ = ""
pos% = InStr(cmd$, "(")
For c% = pos% + 1 To Len(cmd$)
    ch$ = Mid$(cmd$, c%, 1)
    If ch$ = ")" Or ch$ = "," Then
        frmMain.lblParam(p%).Caption = "&" + LTrim$(Str$(p% + 1)) + ": " + par$
        frmMain.txtParam(p%).Enabled = True
        frmMain.txtParam(p%).Visible = True
        If ch$ = ")" Then Exit For
        p% = p% + 1
        par$ = ""
    Else
        par$ = par$ + ch$
    End If
Next c%

' Replace params in command with ("<n>")
cmd$ = Left$(cmd$, pos%) + "<1>"
For p% = 1 To 5
    If frmMain.txtParam(p%).Enabled Then
        cmd$ = cmd$ + ",<" + LTrim$(Str$(p% + 1)) + ">"
    Else
        Exit For
    End If
Next p%
cmd$ = cmd$ + ")]"
frmMain.cmbCommand.Text = cmd$

' Move cursor to param#1
frmMain.txtParam(0).SetFocus

SP_Exit:
End Sub

Sub ShowReply ()

' Show only the first 60 characters,
' leaving the rest intact for display
' via the "More text" button.
frmMain.lblRetMsg.Caption = REPLY$
If Len(REPLY$) > 60 Then
    frmMain.lblRetMsg.Caption = Left$(REPLY$, 40) + "..."
End If

End Sub

